Index: orxonox/trunk/configure.ac
===================================================================
--- orxonox/trunk/configure.ac	(revision 4329)
+++ orxonox/trunk/configure.ac	(revision 4338)
@@ -519,4 +519,5 @@
 		 src/lib/graphics/Makefile
 		 src/lib/graphics/importer/Makefile
+		 src/lib/physics/Makefile
 		 src/lib/gui/Makefile
 		 src/lib/gui/console/Makefile
@@ -526,4 +527,5 @@
 		 src/subprojects/testmain/Makefile
 		 src/subprojects/importer/Makefile
+		 src/subprojects/particles/Makefile
 		 src/subprojects/gui/Makefile
 		 ])
Index: orxonox/trunk/src/Makefile.am
===================================================================
--- orxonox/trunk/src/Makefile.am	(revision 4329)
+++ orxonox/trunk/src/Makefile.am	(revision 4338)
@@ -15,4 +15,6 @@
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/math
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/tinyxml
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/physics
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/physics/fields
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/defs
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/font
@@ -35,8 +37,12 @@
 
 orxonox_DEPENDENCIES = lib/gui/gui/libORXgui.a \
-		       lib/tinyxml/libtinyxml.a
+		       lib/physics/libORXphysics.a \
+		       lib/tinyxml/libtinyxml.a 
+
 orxonox_LDADD = lib/gui/gui/libORXgui.a \
+		lib/physics/libORXphysics.a \
                 lib/tinyxml/libtinyxml.a \
                 $(GTK2_LIBS) $(GTHREAD_LIBS) $(CURL_LIBS)
+
 
 orxonox_SOURCES= orxonox.cc \
@@ -55,4 +61,5 @@
 		 util/loading/factory.cc \
 		 util/loading/load_param.cc \
+		 util/state.cc \
 		 story_entities/story_entity.cc \
 		 story_entities/campaign.cc \
@@ -112,4 +119,5 @@
 		 util/object_manager.h \
 		 util/garbage_collector.h \
+		 util/state.h \
 		 story_entities/story_entity.h \
 		 story_entities/story_def.h \
Index: orxonox/trunk/src/lib/Makefile.am
===================================================================
--- orxonox/trunk/src/lib/Makefile.am	(revision 4329)
+++ orxonox/trunk/src/lib/Makefile.am	(revision 4338)
@@ -3,4 +3,5 @@
 
 SUBDIRS = graphics \
+	  physics \
 	  tinyxml \
 	  $(GTK_PROGS)
Index: orxonox/trunk/src/lib/coord/p_node.h
===================================================================
--- orxonox/trunk/src/lib/coord/p_node.h	(revision 4329)
+++ orxonox/trunk/src/lib/coord/p_node.h	(revision 4338)
@@ -73,4 +73,6 @@
   /** \returns the Velocity of the Node */
   inline const Vector& getVelocity() const {return this->velocity;}
+  /** \returns the last calculated coordinate */
+  inline Vector getLastAbsCoor(void) {return this->lastAbsCoordinate;}
 
   void addChild (PNode* pNode, int parentingMode = DEFAULT_MODE);
Index: orxonox/trunk/src/lib/graphics/light.h
===================================================================
--- orxonox/trunk/src/lib/graphics/light.h	(revision 4329)
+++ orxonox/trunk/src/lib/graphics/light.h	(revision 4338)
@@ -11,5 +11,5 @@
 #define _LIGHT_H
 
-#include "world_entity.h"
+#include "p_node.h"
 #include "glincl.h"
 
@@ -21,5 +21,5 @@
 
 //! A class that handles Lights. The LightManager operates on this.
-class Light : public WorldEntity
+class Light : public PNode
 {
  public:
Index: orxonox/trunk/src/lib/graphics/particles/particle_emitter.cc
===================================================================
--- orxonox/trunk/src/lib/graphics/particles/particle_emitter.cc	(revision 4329)
+++ orxonox/trunk/src/lib/graphics/particles/particle_emitter.cc	(revision 4338)
@@ -31,8 +31,11 @@
 {
    this->setClassID(CL_PARTICLE_EMITTER, "ParticleEmitter");
+
+   this->type = EMITTER_DOT;
+   this->emitterSize = 1.0;
    this->direction = direction;
    this->setSpread(angle);
    this->setEmissionRate(emissionRate);
-   this->setVelocity(velocity);
+   this->setEmissionVelocity(velocity);
 
    this->saveTime = 0.0;
@@ -50,5 +53,4 @@
 {
   ParticleEngine::getInstance()->removeEmitter(this);
-  
 }
 
@@ -71,4 +73,20 @@
 
 /**
+   \param type the new Type of this emitter
+*/
+void ParticleEmitter::setType(EMITTER_TYPE type)
+{
+  this->type = type;
+}
+
+void ParticleEmitter::setSize(float emitterSize)
+{
+  if (emitterSize > 0.0)
+    this->emitterSize = emitterSize;
+  else
+    emitterSize = 0.0;
+}
+
+/**
    \brief set the emission rate
    \param sets the number of particles emitted per second
@@ -79,5 +97,8 @@
 void ParticleEmitter::setEmissionRate(float emissionRate)
 {
-  this->emissionRate = emissionRate;
+  if (emissionRate > 0.0)
+    this->emissionRate = emissionRate;
+  else
+    this->emissionRate = 0.0;
 }
 
@@ -104,5 +125,5 @@
    you may want to use the animation class
 */
-void ParticleEmitter::setVelocity(float velocity, float randomVelocity)
+void ParticleEmitter::setEmissionVelocity(float velocity, float randomVelocity)
 {
   this->velocity = velocity;
@@ -139,7 +160,19 @@
 
 	    // this should spread the Particles evenly. if the Emitter is moved around quickly
-	    Vector equalSpread = this->getVelocity() * random()/RAND_MAX * dt;
+	    Vector equalSpread = this->getVelocity() * rand()/RAND_MAX * dt;
+	    Vector extension; // the Vector for different fields.
 
-	    system->addParticle(this->getAbsCoor() - equalSpread, velocityV);
+	    if (this->type & 2)
+	      {
+		extension = Vector(this->emitterSize * ((float)rand()/RAND_MAX -.5), 0, this->emitterSize * ((float)rand()/RAND_MAX - .5));
+		extension = this->getAbsDir().apply(extension);
+	      }
+	    else if (this->type & 8)
+	      {
+		extension = Vector((float)rand()/RAND_MAX -.5, (float)rand()/RAND_MAX -.5, (float)rand()/RAND_MAX -.5) * this->emitterSize;
+	      }
+
+	    system->addParticle(this->getAbsCoor() + extension - equalSpread, velocityV);
+	    
 	  }
       }
Index: orxonox/trunk/src/lib/graphics/particles/particle_emitter.h
===================================================================
--- orxonox/trunk/src/lib/graphics/particles/particle_emitter.h	(revision 4329)
+++ orxonox/trunk/src/lib/graphics/particles/particle_emitter.h	(revision 4338)
@@ -13,8 +13,9 @@
 class ParticleSystem;
 
-typedef enum EMITTER_TYPE {EMITTER_DOT,
-			   EMITTER_PLANE,
-			   EMITTER_SPHERE,
-			   EMITTER_CUBE};
+//! The form of the Emitter to emit from
+typedef enum EMITTER_TYPE {EMITTER_DOT   = 1,
+			   EMITTER_PLANE = 2,
+			   EMITTER_SPHERE= 4,
+			   EMITTER_CUBE  = 8};
 
 //! A default singleton class.
@@ -32,11 +33,26 @@
 
   /* controlling the behavour: these can be used as Animation interfaces */
+  void setType(EMITTER_TYPE type);
+  void setSize(float emitterSize);
   void setEmissionRate(float emissionRate);
   void setSpread(float angle, float randomAngle = 0.0);
-  void setVelocity(float velocity, float randomVelocity = 0.0);
+  void setEmissionVelocity(float velocity, float randomVelocity = 0.0);
+
+  /** \returns the type of the emitter */
+  inline EMITTER_TYPE getType(void) const { return this->type; };
+  /** \returns the Size of the emitter */
+  inline float getSize(void) const { return this->emitterSize; };
+  /** \returns the emissionRate */
+  inline float getEmissionRate(void) const { return this->emissionRate; };
+  /** \returns the SpreadAngle of the emitter */
+  inline float getSpread(void) { return this->angle; };
+  /** \returns the EmissionVelocity of the emitter */
+  inline float getEmissionVelocity(void) { return this->velocity; };
 
   void debug(void);
 
  private:
+  EMITTER_TYPE type;    //!< The type of emitter this is
+  float emitterSize;    //!< The size of the emitter (not for EMITTER_DOT)
   Vector direction;     //!< emition direction
   float angle;          //!< max angle from the direction of the emitter
Index: orxonox/trunk/src/lib/graphics/particles/particle_engine.cc
===================================================================
--- orxonox/trunk/src/lib/graphics/particles/particle_engine.cc	(revision 4329)
+++ orxonox/trunk/src/lib/graphics/particles/particle_engine.cc	(revision 4338)
@@ -267,4 +267,93 @@
 
 /**
+   \param systemName the name of the system to search for
+   \returns the system called by systemName or NULL if not found
+*/
+ParticleSystem* ParticleEngine::getSystemByName(const char* systemName) const
+{
+  tIterator<ParticleSystem>* tmpIt = systemList->getIterator();
+  ParticleSystem* tmpSys = tmpIt->nextElement();
+  while(tmpSys)
+    {
+      if (!strcmp(systemName, tmpSys->getName()))
+	{
+	  delete tmpIt;
+	  return tmpSys;
+	}
+      tmpSys = tmpIt->nextElement();
+    }
+  delete tmpIt;
+  return NULL;
+}
+
+/**
+   \param number the n-th system to return
+   \returns the system called by number or NULL if not found
+*/
+ParticleSystem* ParticleEngine::getSystemByNumber(unsigned int number) const
+{
+  int count = 0;
+  tIterator<ParticleSystem>* tmpIt = systemList->getIterator();
+  ParticleSystem* tmpSys = tmpIt->nextElement();
+  while(tmpSys)
+    {
+      count++;
+      if ( count == number)
+	{
+	  delete tmpIt;
+	  return tmpSys;
+	}
+      tmpSys = tmpIt->nextElement();
+    }
+  delete tmpIt;
+  return NULL;
+}
+
+/**
+   \param emitterName the name of the emitter to search for
+   \returns the emitter called by emitterName or NULL if not found
+*/
+ParticleEmitter* ParticleEngine::getEmitterByName(const char* emitterName) const
+{
+  tIterator<ParticleEmitter>* tmpIt = emitterList->getIterator();
+  ParticleEmitter* tmpEmit = tmpIt->nextElement();
+  while(tmpEmit)
+    {
+      if (!strcmp(emitterName, tmpEmit->getName()))
+	{
+	  delete tmpIt;
+	  return tmpEmit;
+	}
+      tmpEmit = tmpIt->nextElement();
+    }
+  delete tmpIt;
+  return NULL;
+}
+
+
+/**
+   \param number the n-th emitter to return
+   \returns the emitter called by number or NULL if not found
+*/
+ParticleEmitter* ParticleEngine::getEmitterByNumber(unsigned int number) const
+{
+  int count = 0;
+  tIterator<ParticleEmitter>* tmpIt = emitterList->getIterator();
+  ParticleEmitter* tmpEmit = tmpIt->nextElement();
+  while(tmpEmit)
+    {
+      count++;
+      if ( count == number)
+	{
+	  delete tmpIt;
+	  return tmpEmit;
+	}
+      tmpEmit = tmpIt->nextElement();
+    }
+  delete tmpIt;
+  return NULL;
+}
+
+/**
    \brief outputs some nice debug information
 */
Index: orxonox/trunk/src/lib/graphics/particles/particle_engine.h
===================================================================
--- orxonox/trunk/src/lib/graphics/particles/particle_engine.h	(revision 4329)
+++ orxonox/trunk/src/lib/graphics/particles/particle_engine.h	(revision 4338)
@@ -13,6 +13,4 @@
 // FORWARD DEFINITION 
 template<class T> class tList;
-class ParticleSystem;
-class ParticleEmitter;
 
 struct ParticleConnection
@@ -41,4 +39,9 @@
   bool breakConnection(ParticleConnection* connection);
 
+  ParticleSystem* getSystemByName(const char* systemName) const;
+  ParticleSystem* getSystemByNumber(unsigned int number) const;
+  ParticleEmitter* getEmitterByName(const char* emitterName) const;
+  ParticleEmitter* getEmitterByNumber(unsigned int number) const;
+
   void debug();
 
Index: orxonox/trunk/src/lib/graphics/particles/particle_system.cc
===================================================================
--- orxonox/trunk/src/lib/graphics/particles/particle_system.cc	(revision 4329)
+++ orxonox/trunk/src/lib/graphics/particles/particle_system.cc	(revision 4338)
@@ -20,6 +20,14 @@
 #include "particle_emitter.h"
 #include "particle_engine.h"
+
+#include "field.h"
+
 #include "compiler.h"
 #include "material.h"
+#include "state.h"
+
+
+// needed to find the Position of the Camera
+#include "world.h"
 
 using namespace std;
@@ -34,18 +42,19 @@
 ParticleSystem::ParticleSystem (unsigned int maxCount, PARTICLE_TYPE type)
 {
-   this->setClassID(CL_PARTICLE_SYSTEM, "ParticleSystem");
-   this->material = NULL;
-   this->name = NULL;
-   this->maxCount = maxCount;
-   this->count = 0;
-   this->particles = NULL;
-   this->deadList = NULL;
-   this->setConserve(1);
-   this->setLifeSpan(1);
-   this->setInheritSpeed(0);
-   this->glID = NULL;
-   this->setRadius(1.0, 1.0, 0.0);
-   this->setType(type, 1);
-   ParticleEngine::getInstance()->addSystem(this);
+  this->setClassID(CL_PARTICLE_SYSTEM, "ParticleSystem");
+  this->material = NULL;
+  this->name = NULL;
+  this->maxCount = maxCount;
+  this->count = 0;
+  this->particles = NULL;
+  this->deadList = NULL;
+  this->setConserve(1);
+  this->setLifeSpan(1);
+  this->setInheritSpeed(0);
+  this->glID = NULL;
+  this->setRadius(1.0, 1.0, 0.0);
+  this->setType(type, 1);
+  this->setColor(1.0,1.0,1.0,1.0, .5,.5,.5,.5, .0,.0,.0,.0);
+  ParticleEngine::getInstance()->addSystem(this);
 }
 
@@ -106,29 +115,22 @@
   this->particleType = particleType;
   this->dialectCount = count;
-  if (glID != NULL)
-    delete glID;
-
-  glID = new GLuint[count];
-  for (int i = 0; i< count; i++)
-    glID[i] = 0;
-
-  glID[0] = glGenLists(count);
-  
-  material = new Material("transperencyMap");
-  material->setDiffuseMap("pictures/radialTransparency.png");
-  //  material->setTransparency(.5);
-
-  glNewList(glID[0], GL_COMPILE);
-  glBegin(GL_TRIANGLE_STRIP);
-  glTexCoord2f(1, 1);
-  glVertex3f(0.0, .5, .5);
-  glTexCoord2f(1, 0);
-  glVertex3f(0.0, -.5, .5);
-  glTexCoord2f(0, 1);
-  glVertex3f(0.0, .5, -.5);
-  glTexCoord2f(0, 0);
-  glVertex3f(0.0, -.5, -.5);
-  glEnd();
-  glEndList();
+  //  if (glID != NULL)
+  //    delete glID;
+
+  //  glID = new GLuint[count];
+  //  for (int i = 0; i< count; i++)
+  //    glID[i] = 0;
+
+  //  glID[0] = glGenLists(count);
+  if (this->material)
+    delete this->material;
+  this->material = NULL;
+
+  if (this->particleType == PARTICLE_SPRITE)
+    {
+      this->material = new Material("transperencyMap");
+      this->material->setDiffuseMap("pictures/radialTransparency.png");
+      //  material->setTransparency(.5);
+    }
 }
 
@@ -192,4 +194,29 @@
 }
 
+
+/**
+   \brief Tells the ParticleSystem how it should iterate the color over time
+   \param ....
+*/
+void ParticleSystem::setColor(GLfloat br, GLfloat bg, GLfloat bb, GLfloat ba,
+			      GLfloat mr, GLfloat mg, GLfloat mb, GLfloat ma,
+			      GLfloat er, GLfloat eg, GLfloat eb, GLfloat ea)
+{
+  this->startColor[0] = br;
+  this->startColor[1] = bg;
+  this->startColor[2] = bb;
+  this->startColor[3] = ba;
+
+  this->midColor[0] = mr;
+  this->midColor[1] = mg;
+  this->midColor[2] = mb;
+  this->midColor[3] = ma;
+
+  this->endColor[0] = er;
+  this->endColor[1] = eg;
+  this->endColor[2] = eb;
+  this->endColor[3] = ea;
+}
+
 /**
    \brief ticks the system.
@@ -207,11 +234,30 @@
       tickPart->radius += tickPart->radiusIt * dt;
 
+      // applying force to the System.
+      tickPart->velocity += tickPart->extForce * tickPart->mass;
+      tickPart->extForce = Vector(0,0,0);
+
+      // applying Color
+      //! \todo better algorithm to do this \todo also implement the midColor
+      if (tickPart->lifeCycle < .5)
+	{
+	  tickPart->color[0] = this->startColor[0] *(1.0-tickPart->lifeCycle*2.0) + this->midColor[0] *(tickPart->lifeCycle*2);
+	  tickPart->color[1] = this->startColor[1] *(1.0-tickPart->lifeCycle*2.0) + this->midColor[1] *(tickPart->lifeCycle*2);
+	  tickPart->color[2] = this->startColor[2] *(1.0-tickPart->lifeCycle*2.0) + this->midColor[2] *(tickPart->lifeCycle*2);
+	  tickPart->color[3] = this->startColor[3] *(1.0-tickPart->lifeCycle*2.0) + this->midColor[3] *(tickPart->lifeCycle*2);
+	}
+      else
+	{
+	  tickPart->color[0] = this->midColor[0] *(2.0-tickPart->lifeCycle*2.0) + this->endColor[0] *(tickPart->lifeCycle*2);
+	  tickPart->color[1] = this->midColor[1] *(2.0-tickPart->lifeCycle*2.0) + this->endColor[1] *(tickPart->lifeCycle*2);
+	  tickPart->color[2] = this->midColor[2] *(2.0-tickPart->lifeCycle*2.0) + this->endColor[2] *(tickPart->lifeCycle*2);
+	  tickPart->color[3] = this->midColor[3] *(2.0-tickPart->lifeCycle*2.0) + this->endColor[3] *(tickPart->lifeCycle*2);
+	}	  
       // many more to come
-
 
       if (this->conserve < 1.0)
 	tickPart->velocity = tickPart->velocity * this->conserve;
       // find out if we have to delete tickPart
-      if ((tickPart->timeToLive -= dt) <= 0)
+      if ((tickPart->lifeCycle += dt/tickPart->lifeTime) >= 1.0)
 	{
 	  // remove the particle from the list
@@ -241,39 +287,87 @@
 }
 
+/** 
+    \brief applies some force to a Particle.
+ */
+void ParticleSystem::applyField(float dt, Field* field)
+{
+  Particle* tickPart = particles;
+  while (tickPart)
+    {
+      tickPart->extForce += field->calcForce(dt, tickPart->position);
+      tickPart = tickPart->next;
+    }
+}
+
+
 /**
    \brief draws all the Particles of this System
    \param the time passed in seconds (since the last draw)
+
+   The Cases in this Function all do the same:
+   Drawing all the particles with the appropriate Type.
+   This is just the fastest Way to do this, but will most likely be changed in the future.
 */
 void ParticleSystem::draw(float dt)
 {
   glPushAttrib(GL_ENABLE_BIT);
-  //  material->select();
+  glDisable(GL_LIGHTING);
+
   Particle* drawPart = particles;
-
+      
   switch (this->particleType)
     {
+    default:
     case PARTICLE_SPRITE:
       glMatrixMode(GL_MODELVIEW);
-      //  glDisable(GL_LIGHTING);
+      glDisable(GL_DEPTH_TEST);
+
       material->select(); 
-      glDisable(GL_DEPTH_TEST);
+      //      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_MODULATE);
+      
+
       while (likely(drawPart != NULL))
 	{
-	  glPushMatrix();
-	  glTranslatef(drawPart->position.x, drawPart->position.y, drawPart->position.z);
-	  glScalef(drawPart->radius, drawPart->radius, drawPart->radius);
-	  glCallList(*this->glID);
-	  
-	  //glVertex3f(drawPart->position.x, drawPart->position.y, drawPart->position.z);
+	  glColor4fv(drawPart->color);
+	  //! \todo implement a faster code for the look-at Camera algorithm.
+
+	  const PNode* camera = State::getInstance()->getCamera();  //!< \todo MUST be different
+	  Vector cameraPos = camera->getAbsCoor();
+	  Vector cameraTargetPos = State::getInstance()->getCameraTarget()->getAbsCoor();
+	  Vector view = cameraTargetPos - cameraPos;
+	  Vector up = Vector(0, 1, 0);
+	  up = camera->getAbsDir().apply(up);
+	  Vector h = up.cross(view);
+	  Vector v = h.cross(view);
+	  h.normalize();
+	  v.normalize();
+	  v *= .5 * drawPart->radius;
+	  h *= .5 * drawPart->radius;
+
+	  glBegin(GL_TRIANGLE_STRIP);
+	  glTexCoord2i(1, 1);
+	  glVertex3f(drawPart->position.x - h.x - v.x,
+		     drawPart->position.y - h.y - v.y,
+		     drawPart->position.z - h.z - v.z);
+	  glTexCoord2i(0, 1);
+	  glVertex3f(drawPart->position.x - h.x + v.x,
+		     drawPart->position.y - h.y + v.y,
+		     drawPart->position.z - h.z + v.z);
+	  glTexCoord2i(1, 0);
+	  glVertex3f(drawPart->position.x + h.x - v.x,
+		     drawPart->position.y + h.y - v.y,
+		     drawPart->position.z + h.z - v.z);
+	  glTexCoord2i(0, 0);
+	  glVertex3f(drawPart->position.x + h.x + v.x,
+		     drawPart->position.y + h.y + v.y,
+		     drawPart->position.z + h.z + v.z);
+
+	  glEnd();
+  
 	  drawPart = drawPart->next;
-	  glPopMatrix();
-	}
-      //      glEnd();
-      
-      //  glEnable(GL_LIGHTING);
-      
-      glEnable(GL_DEPTH_TEST);
+	}
+
+      
       break;
-    default:
 
     case PARTICLE_SPARK:
@@ -282,4 +376,5 @@
       while (likely(drawPart != NULL))
 	{
+	  glColor4fv(drawPart->color);
 	  glVertex3f(drawPart->position.x, drawPart->position.y, drawPart->position.z);
 	  glVertex3f(drawPart->position.x - drawPart->velocity.x,
@@ -295,4 +390,6 @@
       while (likely(drawPart != NULL))
 	{
+	  glColor4fv(drawPart->color);
+
 	  glLineWidth(drawPart->radius);
 
@@ -349,5 +446,6 @@
 	}
       
-      particles->timeToLive = this->lifeSpan + (float)(rand()/RAND_MAX)* this->randomLifeSpan;
+      particles->lifeTime = this->lifeSpan + (float)(rand()/RAND_MAX)* this->randomLifeSpan;
+      particles->lifeCycle = 0.0;
       particles->position = position;
       particles->velocity = velocity;
@@ -357,5 +455,5 @@
       particles->radius = this->startRadius + (rand()/RAND_MAX-.5)*this->randomStartRadius;
       
-      particles->radiusIt = (this->endRadius + (rand()/RAND_MAX-.5)*this->randomEndRadius - particles->radius) / particles->timeToLive;
+      particles->radiusIt = (this->endRadius + (rand()/RAND_MAX-.5)*this->randomEndRadius - particles->radius) / particles->lifeTime;
 
       ++this->count;
Index: orxonox/trunk/src/lib/graphics/particles/particle_system.h
===================================================================
--- orxonox/trunk/src/lib/graphics/particles/particle_system.h	(revision 4329)
+++ orxonox/trunk/src/lib/graphics/particles/particle_system.h	(revision 4338)
@@ -31,16 +31,21 @@
 class Material;
 class ParticleEmitter;
-
+class Field;
 
 //! A struct for one Particle
 typedef struct Particle
 {
-  float timeToLive;           //!< The time this particle lives from NOW on.
+  float lifeTime;             //!< The time this particle has to live.
+  float lifeCycle;            //!< The fraction of time passed. (in percentage of its lifeTime)
+
   Vector position;            //!< The current position of this particle.
   Vector velocity;            //!< The current velocity of this particle.
+  Vector extForce;            //!< The external Force that influences this Particle.
   Quaternion rotation;        //!< The current rotation of this particle.
   float mass;                 //!< The mass of this particle.
   float radius;               //!< The current size of this particle.
   float radiusIt;             //!< The difference of the Size per second.
+
+  GLfloat color [4];          //!< A Color for the particles.
 
   PARTICLE_TYPE type;
@@ -69,4 +74,27 @@
   void setMass(float mass, float randomMass);
 
+  void setColor(GLfloat br, GLfloat bg, GLfloat bb, GLfloat ba,
+		GLfloat mr, GLfloat mg, GLfloat mb, GLfloat ma,
+		GLfloat er, GLfloat eg, GLfloat eb, GLfloat ea);
+
+  /** \returns the Type of the particles */
+  inline PARTICLE_TYPE getType(void) const { return this->particleType; };
+  /** \returns the Material that lies on this particles */
+  inline const Material* getMaterial(void) const { return this->material; };
+  /** \returns the inherit-speed-factor */
+  inline float getInheritSpeed(void) const { return this->inheritSpeed; };
+  /** \returns the lifespan of the particles */
+  inline float getLifeSpan(void) const { return this->lifeSpan; };
+  /** \returns the starting-radius of the particles */
+  inline float getStartRadius(void) const { return this->startRadius; };
+  /** \returns the end-radius of the particles */
+  inline float getEndRadius(void) const { return this->endRadius; };
+  /** \returns the conserve-factor of the particles */
+  inline float getConserve(void) const { return this->conserve; };
+  /** \returns the initial mass of the particles */
+  inline float getMass(void) const { return this->initialMass; };
+
+  void applyField(float dt, Field* field);
+
   void tick(float dt);
   void draw(float dt);
@@ -79,12 +107,16 @@
   float conserve;            //!< How much energy gets conserved to the next Tick.
   float lifeSpan;            //!< Initial lifetime of a Particle.
-  float randomLifeSpan;
-  float startRadius;
-  float endRadius;
-  float randomStartRadius;
-  float randomEndRadius;
-  float initialMass;
-  float randomInitialMass;
-  float inheritSpeed;
+  float randomLifeSpan;      //!< A random value for the Lifespan (around the initial lifetime)
+  float startRadius;         //!< The beginning Radius of the Particle
+  float endRadius;           //!< The end Radius of the Particle
+  float randomStartRadius;   //!< The Random start Radius (begin + rand*randomValue)
+  float randomEndRadius;     //!< Random end value
+  float initialMass;         //!< The initial Mass of the Particle
+  float randomInitialMass;   //!< The random initial Mass of the Particle
+  float inheritSpeed;        //!< How much speed the particle inherits from the Emitters speed \todo move this to the emitter
+
+  GLfloat startColor[4];     //!< Color of the Particle at the beginning
+  GLfloat midColor[4];       //!< Color of the Particle at the middle of its lifeSpan
+  GLfloat endColor[4];       //!< Color of the Particle at the end of its lifeSpan
 
   // particles
Index: orxonox/trunk/src/lib/gui/gui/Makefile.am
===================================================================
--- orxonox/trunk/src/lib/gui/gui/Makefile.am	(revision 4329)
+++ orxonox/trunk/src/lib/gui/gui/Makefile.am	(revision 4338)
@@ -25,5 +25,6 @@
 noinst_LIBRARIES = libORXgui.a 
 
-libORXgui_a_CPPFLAGS=$(GTK2_CFLAGS) $(GTHREAD_CFLAGS) $(CURL_CFLAGS) $(MSBITFIELDS)
+libORXgui_a_CPPFLAGS = -DBUILD_ORXONOX \
+			$(GTK2_CFLAGS) $(GTHREAD_CFLAGS) $(CURL_CFLAGS) $(MSBITFIELDS)
 
 libORXgui_a_SOURCES = gui.cc \
Index: orxonox/trunk/src/lib/gui/gui/gui_gtk.cc
===================================================================
--- orxonox/trunk/src/lib/gui/gui/gui_gtk.cc	(revision 4329)
+++ orxonox/trunk/src/lib/gui/gui/gui_gtk.cc	(revision 4338)
@@ -47,6 +47,11 @@
 bool initGUI(int argc, char *argv[])
 {
-  executable = new char[strlen(argv[0])+1];
-  strcpy(executable, argv[0]);
+  if (argv)
+    {
+      executable = new char[strlen(argv[0])+1];
+      strcpy(executable, argv[0]);
+    }
+  else
+    executable = NULL;
 
 #ifdef HAVE_GTK2
@@ -1073,12 +1078,14 @@
 #ifdef HAVE_GTK2
 /** 
-    \brief Signal OptionChange writes the Value from the Slider to its Object-Database.
-    \param widget The widget(Slider) that has a changed Value
-    \param slider the Slider-Object that should receive the change.
+    \brief Signal OptionChange writes the Value from the Option to its Object-Database.
+    \param widget The widget(Option) that has a changed Value
+    \param option the Option-Object that should receive the change.
 */
 gint Option::OptionChange(GtkWidget *widget, Widget* option)
 {
   static_cast<Option*>(option)->changeOption();
-  flags->setTextFromFlags(Window::mainWindow);  //// must be different !!!
+#ifdef BUILD_ORXONOX
+  flags->setTextFromFlags(Window::mainWindow);
+#endif
 }
 #endif /* HAVE_GTK2 */
@@ -1242,7 +1249,7 @@
    \param end The maximal Value of the slider.
 */
-Slider::Slider(const char* slidername, int start, int end)
-{
-  this->optionType = GUI_INT;
+Slider::Slider(const char* slidername, float start, float end)
+{
+  this->optionType = GUI_FLOAT;
 
   this->start = start;
@@ -1268,10 +1275,21 @@
 
 /**
+   \brief sets the exactness of the widget
+   \param exactness count of digits after the dot
+*/
+void Slider::setExactness(int exactness)
+{
+#ifdef HAVE_GTK2
+ gtk_scale_set_digits(GTK_SCALE(this->widget), exactness);
+#endif /* HAVE_GTK2 */
+}
+
+/**
    \brief Setting a new value to the Slider.
    Maybe you also require a Slider::redraw() for this to display
 */
-void Slider::setValue(int value)
-{
-  this->value = value;
+void Slider::setValue(float value)
+{
+  this->fValue = value;
 }
 
@@ -1283,5 +1301,5 @@
 {
 #ifdef HAVE_GTK2
-  gtk_range_set_value(GTK_RANGE(this->widget), this->value);
+  gtk_range_set_value(GTK_RANGE(this->widget), this->fValue);
 #endif /* HAVE_GTK2 */
 }
@@ -1293,5 +1311,5 @@
 {
 #ifdef HAVE_GTK2
-  this->value =(int)gtk_range_get_value(GTK_RANGE(this->widget));
+  this->fValue = gtk_range_get_value(GTK_RANGE(this->widget));
 #else /* HAVE_GTK2 */
   char tmpChar[20];
@@ -1299,12 +1317,26 @@
   scanf("%s", tmpChar);
 
-  if ((this->value = atoi(tmpChar))> this->end)
-    this->value = this->end;
-  if (this->value <= this->start)
-    this->value = this->start;
-
-  PRINT(0)("%s set to: %d\n",this->title, this->value);
-#endif /* HAVE_GTK2 */
-}
+  if ((this->fValue = atof(tmpChar))> this->end)
+    this->fValue = this->end;
+  if (this->fValue <= this->start)
+    this->fValue = this->start;
+
+  PRINT(0)("%s set to: %d\n",this->title, this->fValue);
+#endif /* HAVE_GTK2 */
+}
+
+char* Slider::save(void)
+{
+  char* value = new char [30];
+  sprintf (value, "%f", this->fValue);
+  return value;
+}
+void Slider::load(char* loadString)
+{
+  this->fValue = atof(loadString);
+  PRINT(5)("Loading %s: %s %f\n", this->title, loadString, fValue); 
+  this->redraw();
+}
+
 
 //////////
@@ -1387,8 +1419,17 @@
 {
   MenuItem* tmpItem = this->firstItem;
-  for (int i = 0; i<this->value; i++)
-    tmpItem = tmpItem->next;
-      
-  return tmpItem->name;
+  for (int i = 0; i < this->value; i++)
+    if (tmpItem)
+      tmpItem = tmpItem->next;
+    else
+      break;
+  if (tmpItem)
+    {
+      char* tmpName = new char[strlen(tmpItem->name)+1];
+      strcpy(tmpName, tmpItem->name);
+      return tmpName;
+    }
+  else 
+    return NULL;
 }
 
@@ -1471,5 +1512,5 @@
 
 #endif /* HAVE_GTK2 */
-  PRINT(5)("%s set to: %d\n", this->title, this->value);
+  PRINT(1)("%s set to: %d\n", this->title, this->value);
 }
 
Index: orxonox/trunk/src/lib/gui/gui/gui_gtk.h
===================================================================
--- orxonox/trunk/src/lib/gui/gui/gui_gtk.h	(revision 4329)
+++ orxonox/trunk/src/lib/gui/gui/gui_gtk.h	(revision 4338)
@@ -61,4 +61,5 @@
 
   virtual void setTitle(const char* title);  //!< An abstract Function, that sets the title of Widgets.
+  virtual const char* getTitle(void) const { return this->title; };
 
   Widget* findWidgetByName(char* name, unsigned int depth);
@@ -296,13 +297,18 @@
 {
  private:
-  int start;                            //!< The beginning of the Slider-range.
-  int end;                              //!< The end of the Slider-range.
- public:
-  Slider(const char* slidername, int start, int end);
+  float start;                            //!< The beginning of the Slider-range.
+  float end;                              //!< The end of the Slider-range.
+  float fValue;                           //!< a value for the slider
+ public:
+  Slider(const char* slidername, float start, float end);
   virtual ~Slider(void);
 
-  void setValue(int value);
-  virtual void redraw(void);
-  virtual void changeOption(void);
+  void setExactness(int exactness);
+  void setValue(float value);
+  virtual void redraw(void);
+  virtual void changeOption(void);
+
+  virtual char* save(void);
+  virtual void load(char* loadString);
 };
 
Index: orxonox/trunk/src/lib/physics/Makefile.am
===================================================================
--- orxonox/trunk/src/lib/physics/Makefile.am	(revision 4338)
+++ orxonox/trunk/src/lib/physics/Makefile.am	(revision 4338)
@@ -0,0 +1,48 @@
+MAINSRCDIR=../..
+AM_CXXFLAGS=-I$(MAINSRCDIR)
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/world_entities
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/story_entities
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/coord
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/data
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics/importer
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics/particles
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/gui
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/gui/gui
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/lang
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/util
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/math
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/physics
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/physics/fields
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/tinyxml
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/defs
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/font
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/network
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/glmenu
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/ai
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/util
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/util/animation
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/util/common
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/util/loading
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/util/track
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/subprojects
+
+
+noinst_LIBRARIES = libORXphysics.a 
+
+libORXphysics_a_SOURCES = i_physics.cc \
+		       	  physics_connection.cc \
+		          physics_engine.cc \
+		          fields/field.cc \
+		          fields/gravity.cc \
+		          fields/point_gravity.cc \
+		          fields/twirl.cc
+
+noinst_HEADERS= i_physics.h \
+	        physics_connection.h \
+	        physics_engine.h \
+	        fields/field.h \
+	        fields/gravity.h \
+	        fields/point_gravity.h \
+	        fields/twirl.h
